:root {
  --csscube-text-color: #fff;

  --csscube-front-color: #5c57be;
  --csscube-left-color: #473da5;
  --csscube-right-color: #473da5;
  --csscube-up-color: #4b46a9;
  --csscube-down-color: #3c2f8c;
  --csscube-back-color: #3c2f8c;

  --csscube-front-line: #6d6de2;
  --csscube-left-line: #584eb7;
  --csscube-right-line: #584dbd;
  --csscube-up-line: #5d58b8;
  --csscube-down-line: #352a79;
  --csscube-back-line: #352a79;

  --csscube-point-front-color: #9adbd4;
  --csscube-point-left-color: #62c4bd;
  --csscube-point-right-color: #62c4bd;
  --csscube-point-up-color: #6fcdc6;
  --csscube-point-down-color: #3aa5a5;
  --csscube-point-back-color: #3aa5a5;

  --csscube-point-front-line: #cffff8;
  --csscube-point-left-line: #69d0c9;
  --csscube-point-right-line: #6ccfc8;
  --csscube-point-up-line: #7cd9d2;
  --csscube-point-down-line: #349999;
  --csscube-point-back-line: #349999;
}

.cube-wrap {
  position: relative;
  margin: 0rem;
  width: 8em;
  height: 8em;
  /* font-size:55px;  */
  /* em�� cube-wrapy�� font-size 湲곗��쇰줈 �ъ씠利덇� �뚮뜑留� */
  perspective: 160em;
  perspective-origin: 0em 0em;
  transform-style: preserve-3d;
  transform-origin: 0em 0em 0em;
  transform: rotateX(45deg) rotateY(-35deg) rotateZ(15deg);
}

.cube {
  display: block;
  position: absolute;
  left: 4.8em;
  top: 2.8em;
  transform-style: preserve-3d;
  transform-origin: 0em 0em 0em;
  /*animation-delay: 3s;*/
  /*animation-duration: 30s;*/
  animation-iteration-count: infinite;
  animation-timing-function: ease-in-out;
  -webkit-user-select: none;
  user-select: none;
}

.sticker {
  display: block;
  position: absolute;
  width: 1.5em;
  height: 1.5em;
  left: -0.75em;
  top: -0.75em;
  background-color: darkgray;
  opacity: 100%;
  backface-visibility: visible;
  text-align: center;
  box-sizing: border-box;
}

.sticker span {
  font-size: 0;
}

.sticker.front {
  border-right: 2px solid var(--csscube-front-line);
  border-bottom: 2px solid var(--csscube-front-line);
}
/* .sticker.left{
	border-left:2px solid var(--csscube-left-line);
	border-bottom:2px solid var(--csscube-left-line);
}
.sticker.right{
	border-right:2px solid var(--csscube-right-line);
	border-top:2px solid var(--csscube-right-line);
} */
.sticker.up {
  border-left: 2px solid var(--csscube-up-line);
  border-top: 2px solid var(--csscube-up-line);
}
.sticker.down {
  border-right: 2px solid var(--csscube-down-line);
  border-bottom: 2px solid var(--csscube-down-line);
}

.cube-point .sticker.front {
  border-right: 2px solid var(--csscube-point-front-line);
  border-bottom: 2px solid var(--csscube-point-front-line);
}
.cube-point .sticker.left {
  border-left: 2px solid var(--csscube-point-left-line);
  border-bottom: 2px solid var(--csscube-point-left-line);
}
.cube-point .sticker.right {
  border-right: 2px solid var(--csscube-point-right-line);
  border-top: 2px solid var(--csscube-point-right-line);
}
.cube-point .sticker.up {
  border-left: 2px solid var(--csscube-point-up-line);
  border-top: 2px solid var(--csscube-point-up-line);
}
.cube-point .sticker.down {
  border-right: 2px solid var(--csscube-point-down-line);
  border-bottom: 2px solid var(--csscube-point-down-line);
}

.cubie,
.corner,
.edge,
.center {
  display: block;
  position: absolute;
  transform-style: preserve-3d;
  transform-origin: 0em 0em 0em;
  animation-delay: 0;
  animation-duration: 6s;
  animation-timing-function: ease-in-out;
  animation-direction: alternate;
  animation-iteration-count: 2;
}

.sticker.front {
  transform: translateZ(0.75em);
}
.sticker.back {
  transform: rotateY(180deg) translateZ(0.75em);
}
.sticker.back {
  transform: rotateY(180deg) translateZ(0.75em);
}
.sticker.left {
  transform: rotateY(-90deg) translateZ(0.75em);
}
.sticker.right {
  transform: rotateY(90deg) translateZ(0.75em);
}
.sticker.up {
  transform: rotateX(90deg) translateZ(0.75em);
}
.sticker.down {
  transform: rotateX(-90deg) translateZ(0.75em);
}

/* front */
.corner.front.left.up {
  transform: translateX(-1.65em) translateY(-1.65em) translateZ(1.65em);
}
.corner.front.right.up {
  transform: translateX(1.65em) translateY(-1.65em) translateZ(1.65em);
}
.corner.front.left.down {
  transform: translateX(-1.65em) translateY(1.65em) translateZ(1.65em);
}
.corner.front.right.down {
  transform: translateX(1.65em) translateY(1.65em) translateZ(1.65em);
}
.edge.front.up {
  transform: translateY(-1.65em) translateZ(1.65em);
}
.edge.front.down {
  transform: translateY(1.65em) translateZ(1.65em);
}
.edge.front.left {
  transform: translateX(-1.65em) translateZ(1.65em);
}
.edge.front.right {
  transform: translateX(1.65em) translateZ(1.65em);
}
.center.front {
  transform: translateZ(1.65em);
}

/* center */
.edge.left.up {
  transform: translateX(-1.65em) translateY(-1.65em);
}
.edge.right.up {
  transform: translateX(1.65em) translateY(-1.65em);
}
.edge.left.down {
  transform: translateX(-1.65em) translateY(1.65em);
}
.edge.right.down {
  transform: translateX(1.65em) translateY(1.65em);
}
.center.up {
  transform: translateY(-1.65em);
}
.center.down {
  transform: translateY(1.65em);
}
.center.left {
  transform: translateX(-1.65em);
}
.center.right {
  transform: translateX(1.65em);
}

/* back */
.corner.back.left.up {
  transform: translateX(-1.65em) translateY(-1.65em) translateZ(-1.65em);
}
.corner.back.right.up {
  transform: translateX(1.65em) translateY(-1.65em) translateZ(-1.65em);
}
.corner.back.left.down {
  transform: translateX(-1.65em) translateY(1.65em) translateZ(-1.65em);
}
.corner.back.right.down {
  transform: translateX(1.65em) translateY(1.65em) translateZ(-1.65em);
}
.edge.back.up {
  transform: translateY(-1.65em) translateZ(-1.65em);
}
.edge.back.down {
  transform: translateY(1.65em) translateZ(-1.65em);
}
.edge.back.left {
  transform: translateX(-1.65em) translateZ(-1.65em);
}
.edge.back.right {
  transform: translateX(1.65em) translateZ(-1.65em);
}
.center.back {
  transform: translateZ(-1.65em);
}

/* .sticker { background-color: var(--csscube-cube-color); } */

/** cube - color **/
.sticker.front {
  background-color: var(--csscube-front-color);
}
.sticker.back {
  background-color: var(--csscube-back-color);
}
.sticker.left {
  background-color: var(--csscube-left-color);
}
.sticker.right {
  background-color: var(--csscube-right-color);
}
.sticker.up {
  background-color: var(--csscube-up-color);
}
.sticker.down {
  background-color: var(--csscube-down-color);
}

/** cube - color point **/
.cube-point .sticker.front {
  background-color: var(--csscube-point-front-color);
}
.cube-point .sticker.back {
  background-color: var(--csscube-point-back-color);
}
.cube-point .sticker.left {
  background-color: var(--csscube-point-left-color);
}
.cube-point .sticker.right {
  background-color: var(--csscube-point-right-color);
}
.cube-point .sticker.up {
  background-color: var(--csscube-point-up-color);
}
.cube-point .sticker.down {
  background-color: var(--csscube-point-down-color);
}

.corner.front.left.up .front:after,
.edge.front.up .front:after,
.edge.front.left .front:after,
.center.front .front:after,
.edge.front.right .front:after,
.edge.front.down .front:after {
  content: "";
  display: block;
  position: absolute;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  background-position: 0 0;
  background-repeat: no-repeat;
  background-size: 100%;
}
.corner.front.left.up .front:after {
  background-image: url(../icon/cube/icon_cube_01.png);
}
.edge.front.up .front:after {
  background-image: url(../icon/cube/icon_cube_02.png);
}
.edge.front.left .front:after {
  background-image: url(../icon/cube/icon_cube_03.png);
}
.center.front .front:after {
  background-image: url(../icon/cube/icon_cube_04.png);
}
.edge.front.right .front:after {
  background-image: url(../icon/cube/icon_cube_05.png);
}
.edge.front.down .front:after {
  background-image: url(../icon/cube/icon_cube_06.png);
}
